﻿//------------------------------------------------------------------------------
// CCzoomr
//
// BuildServerService.cs
//
//------------------------------------------------------------------------------
// Copyright (c) 2007-2008, Scott Dorman (sj_dorman@hotmail.com)
// All rights reserved.
// 
// Redistribution and use in source and binary forms, with or without 
// modification, are permitted provided that the following conditions are met:
// 
// * Redistributions of source code must retain the above copyright notice, 
//   this list of conditions and the following disclaimer.
// 
// * Redistributions in binary form must reproduce the above copyright notice, 
//   this list of conditions and the following disclaimer in the documentation 
//   and/or other materials provided with the distribution.
// 
// * Neither the name of CCzoomr (http://www.CCzoomr.com) nor the names of its 
//   contributors may be used to endorse or promote products derived from this
//   software without specific prior written permission.
// 
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
// ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
// LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
// CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE. 
//------------------------------------------------------------------------------
using System.Configuration;
using CCzoomr.Configuration;
using CCzoomr.Configuration.Provider;

namespace CCzoomr
{
    public class BuildServerService : IBuildServerService
    {
        #region events
        #endregion

        #region class-wide fields
        private BuildServerSection serverConfiguration;
        private BuildServerProviderCollection providers;
        #endregion

        #region private and internal properties and methods

        #region properties
        #endregion

        #region methods
        #endregion

        #endregion

        #region public properties and methods

        #region properties

        #region Providers
        public ReadOnlyProviderCollection<BuildServerProvider> Providers
        {
            get
            {
                return this.providers.AsReadOnly();   
            }
        }
        #endregion

        #endregion

        #region methods

        #region constructor
        public BuildServerService()
        {
            providers = new BuildServerProviderCollection();

            this.serverConfiguration = (BuildServerSection)ConfigurationManager.GetSection("dashboardSettings/servers");
            ProvidersHelper.InstantiateProviders(this.serverConfiguration.Servers, providers, typeof(BuildServerProvider));
        }
        #endregion

        #endregion

        #endregion
    }
}
