﻿//------------------------------------------------------------------------------
// CCzoomr
//
// ProviderCollection.cs
//
//------------------------------------------------------------------------------
// Copyright (c) 2007-2008, Scott Dorman (sj_dorman@hotmail.com)
// All rights reserved.
// 
// Redistribution and use in source and binary forms, with or without 
// modification, are permitted provided that the following conditions are met:
// 
// * Redistributions of source code must retain the above copyright notice, 
//   this list of conditions and the following disclaimer.
// 
// * Redistributions in binary form must reproduce the above copyright notice, 
//   this list of conditions and the following disclaimer in the documentation 
//   and/or other materials provided with the distribution.
// 
// * Neither the name of CCzoomr (http://www.CCzoomr.com) nor the names of its 
//   contributors may be used to endorse or promote products derived from this
//   software without specific prior written permission.
// 
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
// ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
// LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
// CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE. 
//------------------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.Configuration.Provider;
using System.Globalization;

namespace CCzoomr.Configuration.Provider
{
    /// <summary>
    /// Generic collection of Providers.
    /// </summary>
    public class BuildServerProviderCollection : ProviderCollection
    {
        #region events
        #endregion

        #region class-wide fields
        #endregion

        #region private and internal properties and methods

        #region properties
        #endregion

        #region methods
        #endregion

        #endregion

        #region public properties and methods

        #region properties

        #region indexer
        /// <summary>
        /// Returns a provider by the specified section key.
        /// </summary>
        /// <param name="name"></param>
        /// <returns></returns>
        public new BuildServerProvider this[string name]
        {
            get
            {
                return (BuildServerProvider)base[name];
            }
        }
        #endregion

        #endregion

        #region methods

        #region Add
        /// <summary>
        /// Adds a new provider to the collection.
        /// </summary>
        /// <param name="provider"></param>
        public override void Add(ProviderBase provider)
        {
            if (provider == null)
            {
                throw new ArgumentNullException("provider", Properties.Resources.ArgumentNull_Obj);
            }

            if (!(provider is BuildServerProvider))
            {
                throw new ArgumentException(String.Format(CultureInfo.CurrentUICulture, Properties.Resources.Config_Provider_Must_Implement_Type, typeof(BuildServerProvider).FullName), "provider");
            }
            base.Add(provider);
        }
        #endregion

        #region AsReadOnly
        public ReadOnlyProviderCollection<BuildServerProvider> AsReadOnly()
        {
            List<BuildServerProvider> list = new List<BuildServerProvider>(this.Count);
            foreach (BuildServerProvider item in this)
            {
                list.Add(item);
            }
            ReadOnlyProviderCollection<BuildServerProvider> r = new ReadOnlyProviderCollection<BuildServerProvider>(list);
            return r;
        }
        #endregion

        #endregion

        #endregion
    }
}
